/********************************************************************
 *
 *  Alerts for Steuerung 13.06.2013
 *
 *  R. Kohleick
 *
 *  licensed under GNU GPLv3
 *
 ********************************************************************/


#include <ctype.h>
#include <avr/pgmspace.h>
#include <mystuff.h>
#include <Alerts.h>



Alert::Alert(int val, int t, char *s, char *msg) {

	value=val;
	type=t;
	alertstr=s;
    
    text=msg;
	disarm();
}



void Alert::disarm(void) {
	
	state=disarmed;
}



void Alert::arm(void) {
	
	state=armed;
}


boolean Alert::check(boolean flag) {
	
	if(state!=armed)
		return false;
	
	if(type==LOGIC_ALARM) {
		if (flag)
			state=triggered;
	}
	return (state==triggered);
}



boolean Alert::check(int val) {
	
	if(state!=armed)
		return false;
	
	switch(type) {
		case HIGH_ALARM:
			if (val>value)
				state=triggered;
			break;
			
		case LOW_ALARM:
			if (val<value)
				state=triggered;
			break;
	}
	return (state==triggered);
}



void Alert::acknowledge(void) {
    char s[8];
    
	if(state!=triggered)
		return;					// do nothing

	state=acknowledged;	
	
	switch(type) {
		case HIGH_ALARM:
		case LOW_ALARM:
			strcpy(alertstr,text); 
            sprinttemp(s,value);
			strcat(alertstr,s);
			break;
			
		case LOGIC_ALARM:
			strcpy(alertstr,text);
			break;
	}
}



void Alert::status(void) {
	char t[10];
	
	strcpy(alertstr,text);
	
	switch(type){
		case HIGH_ALARM:
		case LOW_ALARM:
            sprinttemp(t,value);            
			strcat(alertstr,t);
			
		case LOGIC_ALARM:
			break;
	}
	
	switch(state) {
		case disarmed:
			strcat(alertstr, " Dis");
			break;
		case armed:
			strcat(alertstr, " Amd");
			break;
		case triggered:
			strcat(alertstr, " Trg");
			break;
		case acknowledged:
			strcat(alertstr, " Ack");
			break;
	}
	
}
