/********************************************************************
 *
 *  Command Line interpreter for Steuerung 13.06.2013
 *
 *  R. Kohleick
 *
 *  licensed under GNU GPLv3
 *
 ********************************************************************/


#ifndef CommandLine_h
#define CommandLine_h

#define termchar(c) (isspace((c)) || ((c)==0) || ispunct(c))

#define MAXARG 8

#define ERROR 0xFFFFFFFF

#define NOTVALID 0
#define KEYWORD 1
#define ONOFF  2
#define TIME  3
#define VALUE 4
#define SET 5
#define INTEGER 6
#define RESET 7
#define LOG	8


class CLI {

public:	
	CLI(void);
	
	unsigned int interpret(char *line, int *args);
	int Readln(char *b);
	
	
private:
	byte parseatoms(char *line, char *at[]);
	boolean truenumber(char *s);
	boolean onlydigits(char *s, char special);
    void normalize(char *s);
	unsigned long readparams(char *args[], byte number, int *params);
	unsigned int SyntaxCheck(unsigned long type, int *params);
};

#endif
