/***************************
 *
 *
 *	collection of things that i find useful
 *
 *
 *	R. Kohleick	28.10.2010
 *
 * licensed under GNU GPLv3
 *
 **/


#ifndef mystuff_h
#define mystuff_h

#include "Arduino.h"

extern void sprinttime(char *s, byte h, byte m);// prints time in format hh:mm to string
extern void sprintmon(char *s, byte d);			// prints month to string
extern void sprintday(char *s, byte d);			// prints day of week to string

extern void sprintint(int number, char *t, byte field, byte dec=0);
extern void sprinttemp(char *t, int temp);

extern unsigned int scanint(char *s);			// returns the integer in s if any, ignores any non digit char within the chars

extern void leadingzeros(char *s);				// changes spaces to '0' in string s

extern void savetoeeprom(unsigned int offset, unsigned int magic, byte *p, unsigned int n);
extern boolean readfromeeprom(unsigned int offset, unsigned int magic, byte *p, unsigned int n);

extern int Readln(char *b);					// reads string terminated by n, r or ; from Serial to buffer
extern void shiftstring(char *s, byte d);			// shifts string d chars to the right
extern void truncleft(char *s);   // eliminates chars from beginning of string
extern void truncright(char *s);  // eliminates chars from end of string

extern void eliminate(char *s, char c);			// eliminates occurence of c from string

extern void mydelaylong(unsigned long mil);         // delays for mil miliseconds
extern void mydelayint(unsigned int mil);         // delays for mil miliseconds

extern byte mystrcat(char *s1, char *s2, byte len); // concats s2 to s1 but only up to len chars

#endif

