/***************************
 *
 *
 *	Library to organize storage of strings to eeprom memory
 *
 *
 *	R. Kohleick	29.12.2012
 *
 * licensed under GNU GPLv3
 *
 **/


#include <streeng.h>
#include <EEPROM.h>
#include "Arduino.h"

void streeng::init(void) {
	EEPROM.write(offset,0);
}

void streeng::setbaseindex(int b) {
	basis=b;
}

streeng::streeng(int off) {
	offset=off;
	setbaseindex(0);
}


int streeng::read(char *s , int ndx) {
	int pos=0;
	byte i;
	int ctr=0;
    
	ndx+=basis;
	
	while ((ctr<ndx) && (EEPROM.read(offset+pos)>0)) {
		pos=pos+1+EEPROM.read(offset+pos);
		ctr++;
	} 

	for(i=0; i<EEPROM.read(offset+pos); i++) {
		*s++=EEPROM.read(offset+pos+1+i);
	} 
	*s=0;
	return i;
}

int streeng::write(char *s) {
	int pos=0;
	int ctr=0;
	byte i;
	byte len;
	
	do {	// go to end of text fields
		len=EEPROM.read(offset+pos);
		pos=pos+len+1;
		ctr++;
	} while (len>0);
	
	pos--;
	ctr--;

	for(i=0;s[i]!=0;i++);
	len=min(i, 80);

	if(offset+pos+len+1>1024)	// too large
		return -1;
	
	EEPROM.write(offset+pos, len);
	for(i=0; i<len; i++)
		EEPROM.write(offset+pos+1+i, s[i]);
	EEPROM.write(offset+pos+1+len, 0);
		
	return ctr;
}

/*
void streeng::list(void) {
	int pos=0;
	int ctr=0;
	byte i;
	byte len;
	byte s[STRLEN];
	
	do {	
		len=EEPROM.read(offset+pos);
		if(len>0) {
			for(i=0;i<len;i++) {
				s[i]=EEPROM.read(offset+pos+1+i);
			}
			s[i]=0;
			ctr++;
			Serial.print(ctr,DEC);
			Serial.print(": \t");
			Serial.println(s);
			pos=pos+len+1;
		}
	} while (len>0);	
}*/

