/********************************************************************
 *
 *  V5.7 13.06.2013
 *
 *  R. Kohleick
 *
 *  licensed under GNU GPLv3
 *
 *********************************************************************/

// one wire bus temperature sensors

const byte maxattempts=10;
const int startupsign=-32000;

struct sensor {
	byte address[8];
	boolean polled;
	int temp;
    byte attempts;
};


/*************
 *
 * define some consts to manage the savng of data to eeprom
 *
 */

#define ONEWIRE_SIZE  16

#define EEPROM_CONTROL   (0x10)
#define EEPROM_ALERTHIGH (EEPROM_CONTROL+sizeof(Control)+2)
#define EEPROM_ALERTLOW  (EEPROM_ALERTHIGH+sizeof(Alert)+2)
#define EEPROM_ONEWIRES  (EEPROM_ALERTLOW+sizeof(Alert)+2)
#define EEPROM_RECEIVERS (EEPROM_ONEWIRES+ONEWIRE_SIZE+2)
#define EEPROM_STARTOFSTRINGS (EEPROM_RECEIVERS+PHONEBOOKSIZE)

/*************
 *
 * and magic numbers for integrity verification
 *
 */

#define EEPROM_MAGIC_CONTROL    0x0510    // change magics if datastructure is changed, so that no errors occur
#define EEPROM_MAGIC_RECEIVERS  0x3010
#define EEPROM_MAGIC_ALERT      0x2210
#define EEPROM_MAGIC_ONEWIRES   0x1010


int const eepromoffset=300;
int const eepromindex=41;

byte const buffsize=160;
byte const tempbuffsize=40;

byte const visualization=10;  // show message for this periof of sec

/************
*
* constants to handle communication to and fro gsm
*
**/

enum commsource { none, sms, smsbroadcast, firstinlist, call, voicebroadcast};

