/********************************************************************
 *
 *  String saving into EEProm for Steuerung 13.06.2013
 *
 *  R. Kohleick
 *
 *  licensed under GNU GPLv3
 *
 ********************************************************************/


#include <mystuff.h>
#include <EEPROM.h>
#include <streeng.h>

int const offset=300;

streeng eeprom(offset);

char s[17];

void setup(void) {
 Serial.begin(19200); 
}

void list() {
   	int pos=0;
	int ctr=0;
	byte i;
	byte len;
	char s[80];
	
	do {	
		len=EEPROM.read(offset+pos);
		if(len>0) {
			for(i=0;i<len;i++) {
				s[i]=EEPROM.read(offset+pos+1+i);
			}
			s[i]=0;

			Serial.print(ctr,DEC);
			Serial.print(": \t");
			Serial.println(s);
			pos=pos+len+1;
			ctr++;
		}
	} while (len>0);	
 Serial.println();
 Serial.print("remains: ");
 Serial.println(1024-pos-offset, DEC);
}

void loop() {
    
    eeprom.init();


/******* Controler
*/

eeprom.write("Off");  //0
eeprom.write("Su");
eeprom.write("Mo");
eeprom.write("Tu");
eeprom.write("We");
eeprom.write("Th");
eeprom.write("Fr");
eeprom.write("Sa");
eeprom.write("Mo-Fr");
eeprom.write("Sa,Su");
eeprom.write("Mo-We");
eeprom.write("Th-Fr");
eeprom.write("always");

eeprom.write("Edit Temp");
eeprom.write("Edit Time");
eeprom.write("Delete");

eeprom.write("Add Event");
eeprom.write("Main Menu");

eeprom.write("Edit Profile"); //18

/**********
Command Line Interpreter

*/

eeprom.write("STATUS");      // 19
eeprom.write("ALERT");
eeprom.write("CYCLE");
eeprom.write("ECONOMY");
eeprom.write("COMFORT");
eeprom.write("TEMP");
eeprom.write("ANTIFREEZE");
eeprom.write("PROFILE");
eeprom.write("ON");
eeprom.write("OFF");
eeprom.write("HELP");
eeprom.write("SET");
eeprom.write("RESET");
eeprom.write("TIME");
eeprom.write("COOLER");
eeprom.write("DATE");
eeprom.write("LOG"); //  35

/**
Phonebook
*/

eeprom.write("Main Menu");  //36
eeprom.write("Add Entry");
eeprom.write("Edit");
eeprom.write("Delete");
eeprom.write("Phonebook Editor"); // 40


/**
Main Menu
*/

eeprom.write("Temperature");    // 41 -> 0
eeprom.write("Manual");
eeprom.write("Comfort");
eeprom.write("Economy");
eeprom.write("Antifreeze");

eeprom.write("Cycle");
eeprom.write("On");
eeprom.write("Time");
eeprom.write("Morning");
eeprom.write("Evening");

eeprom.write("Profiles");      //10
eeprom.write("Profile 1");
eeprom.write("Profile 2");
eeprom.write("Profile 3");
eeprom.write("Profile 4");
eeprom.write("Disable all");

eeprom.write("Alerts");
eeprom.write("Lower");
eeprom.write("Value");    // 18
eeprom.write("Upper");

eeprom.write("Off");      // 20

eeprom.write("Setup");

eeprom.write("Defaults");
eeprom.write("Comfort");
eeprom.write("Economy");
eeprom.write("Antifreeze");    //25

eeprom.write("Fctry Defaults");
eeprom.write("Confirm");
eeprom.write("Abort");

eeprom.write("Phonebook");

eeprom.write("Time/Date");  //30
eeprom.write("Time");   
eeprom.write("Date");

eeprom.write("Cooler");

eeprom.write("min. Runtime"); 
eeprom.write("Heater");  // 35

eeprom.write("Hysteresis");
eeprom.write("Swap Sensors");
eeprom.write("Status");
eeprom.write("SMS");

eeprom.write("V5.7 23.02.2013");  // 40
eeprom.write("19200 8N1 no PIN");
eeprom.write("Sensors...");
eeprom.write("no device ?");
eeprom.write("unknown device");
eeprom.write("comm ?");  //45
eeprom.write("no network");

eeprom.write("Display");
eeprom.write("Reset");

eeprom.write("Test");
eeprom.write("Operator");  // 50

list();

while(true);
    
}
